# Created by Adam 'Musketeer925' Seitz
# 26 Feb 2011
import urllib
from Tkinter import *
import tkFont
master = Tk()

master.title("ESO External Friends List")
    
def QueryXML(xml, attribute):
    x = ["<", attribute, ">"]
    x=''.join(x)
    z = xml.split(x, 1)
    x = ["</", attribute, ">"]
    x=''.join(x)
    z=z[1]
    z=z.split(x, 1)
    return z[0]

def AddFriend():
    nfentry = nfe2
    name=nfentry.get()
    url=['http://agecommunity.com/query/query.aspx?name=', name, '&md=user']
    url=''.join(url)
    filehandle = urllib.urlopen(url)
    xml = filehandle.readlines()
    filehandle.close()
    xml=''.join(xml)
    if xml != "<?xml version='1.0' encoding='utf-8'?><error>Invalid md</error>":
        name=QueryXML(xml, "name")
        f = open("Friends.txt", "r")
        filestring = f.read()
        f.close()
        if filestring == "":
            fs = "blank"
        else:
            fs = filestring.split('\n')
        if name in fs:
            FriendListError(name, 1)
            print "Friend Already Added"
        elif xml == "<?xml version='1.0' encoding='utf-8'?><error>Failed to find user</error>":
            print "User does not exist"
        elif fs == "blank":
            fs=name
            f = open("Friends.txt", "w")
            f.write(fs)
            f.close()
        else:
            fs.append(name)
            fs = '\n'.join(fs)
            f = open("Friends.txt", "w")
            f.write(fs)
            f.close()
    nfe2.set("")
    nfentry = nfe2
    
def DeleteFriend():
    ofentry = ofe2
    name=ofentry.get()
    url=['http://agecommunity.com/query/query.aspx?name=', name, '&md=user']
    url=''.join(url)
    filehandle = urllib.urlopen(url)
    xml = filehandle.readlines()
    filehandle.close()
    xml=''.join(xml)
    if xml != "<?xml version='1.0' encoding='utf-8'?><error>Invalid md</error>":
        name=QueryXML(xml, "name")
        f = open("Friends.txt", "r")
        filestring = f.read()
        f.close()
        fs = filestring.split('\n')
        if name in fs:
            fs.remove(name)
            fs = '\n'.join(fs)
            f = open("Friends.txt", "w")
            f.write(fs)
            f.close()
        else:
            FriendListError(name, 2)
    ofe2.set("")
    ofentry = ofe2
        
def IsOnline(name):
    url=['http://agecommunity.com/query/query.aspx?name=', name, '&md=user']
    url=''.join(url)
    filehandle = urllib.urlopen(url)
    xml = filehandle.readlines()
    filehandle.close()
    xml=''.join(xml)
    if xml == "<?xml version='1.0' encoding='utf-8'?><error>Failed to find user</error>":
        print "User does not exist"
    else: 
        datetime = QueryXML(xml, "LastUpdated")
        datetime = datetime.split('T', 1)
        time = datetime[1].split('Z', 1)
        date = datetime[0]
        print "User", name, "is", QueryXML(xml, "presence"), "as of", date, "at", time[0]
        return QueryXML(xml, "presence")
    
def FriendCheck():
    f = open("Friends.txt", "r")
    filestring = f.read()
    f.close()
    if filestring != "":
        fs = filestring.split('\n')
        x=0
        while x <= (len(fs)-1):
            if IsOnline(fs[x]) == "online":
                lab = lambda: fs[x]
                lab = Label(lowerframe, text=fs[x])
                lab.grid(column=0, row=x)
            else:
                lab = lambda: fs[x]
                lab = Label(lowerframe, text='')
                lab.grid(column=0, row=x+len(fs))
            x=x+1
    
def RunTwo(Function1, Function2):
    Function1()
    Function2()
    
def DeleteAllFriends():
    fs = ""
    f = open("Friends.txt", "w")
    f.write(fs)
    f.close()
 
def DAFPop():
    DAFpopup = Toplevel()
    DAFpopup.title("Confirm")
    DAFframe = Frame(DAFpopup)
    DAFframe.grid(columnspan=4, column=0, row=0)
    F1 = DeleteAllFriends
    F2 = DAFpopup.destroy
    Q1 = lambda: RunTwo(F1, F2)
    DAFL1 = Label(DAFframe, text="This delete all of your friends. Are you sure you wish to continue?")
    DAFL1.grid()
    DAFOK = Button(DAFpopup, width=10, text="Yes", command=Q1)
    DAFOK.grid(column=1, row=1)
    DAFNO = Button(DAFpopup, width=10, text="No", command=DAFpopup.destroy)
    DAFNO.grid(column=2, row=1)

def FriendListError(name, case):
    FPApopup = Toplevel()
    FPApopup.title("Error")
    if case == 1:
        FPAtext = name+" is already on your friends list."
    elif case == 2:
        FPAtext = name+" is not on your friends list."
    FPAL1 = Label(FPApopup, text=FPAtext)
    FPAL1.grid()
    FPAOK = Button(FPApopup, width=10, text="OK", command=FPApopup.destroy)
    FPAOK.grid(column=0, row=1)

def SeeAll():
    SApopup = Toplevel()
    f = open('Friends.txt', 'r')
    filestring = f.readlines()
    filestring='\n'.join(filestring)
    fs = filestring.split('\n')
    x=0
    while x<len(fs):
        offlinefriend = Label(SApopup, text=fs[x])
        offlinefriend.grid(column=0, row=x)
        x=x+1
    SAAOK = Button(SApopup, width=10, text="OK", command=SApopup.destroy)
    SAAOK.grid(column=0, row=x)

    
frame = Frame(master, bd=5)
frame.grid()
 
friendlist = Frame(frame, bd=5, width=150, height=400)
friendlist.grid(column=0, row=0, rowspan=15)
    
lon = Frame(friendlist, bd=2, width=150, height=10)
lon.grid()
    
Lonline = Label(lon, text="Friends Online")
Lonline.grid(column=0, row=1)
underlined = tkFont.Font(Lonline, Lonline.cget("font"))
underlined.configure(underline=True)
Lonline.configure(font=underlined)
    
lowerframe = Frame(friendlist, bd=2, width=150, height=390)
lowerframe.grid()
    
lowerframe.grid_propagate(0)
   
newfriendframe = Frame(frame, bd=2)
newfriendframe.grid(column=1, row=0)
    
nfe2 = StringVar()
nfentry = Entry(newfriendframe, width=12, textvariable=nfe2)
nfentry.grid()
nfe2.set("")
nfentry = nfe2.get()
    
newfriend = Button(newfriendframe, text="Add Friend", width=10, command=AddFriend)
newfriend.grid(column=0, row=1)
    
oldfriendframe = Frame(frame, bd=2)
oldfriendframe.grid(column=1, row=1)
   
ofe2 = StringVar()
ofentry = Entry(oldfriendframe, width=12,textvariable=ofe2)
ofentry.grid()
ofe2.set("")
ofentry = ofe2.get()
    
oldfriend = Button(oldfriendframe, text="Delete Friend", width=10, command=DeleteFriend)
oldfriend.grid(column=0, row=1)
    
rof = Button(frame, text="Reset List", width=10, command=DAFPop)
rof.grid(column=1, row=2)
    
update = Button(frame, text="Refresh", width=10, command=FriendCheck)
update.grid(column=1, row=4)
    
close = Button(frame, text="Exit", width=10, command=master.destroy)
close.grid(column=1, row=5)
   
master.mainloop()
